/**************************************************************************/
/*							囲み文字の作成を楽にする					  */
/*															 by お～まち  */
/*												2010.03.04  Version 1.00  */
/**************************************************************************/

app.scriptPreferences.userInteractionLevel=UserInteractionLevels.interactWithAll;
if (app.documents.length < 1){
	alert("ドキュメントを作成するか、開く必要があります");
} else {
	do_script();
}

function do_script () {
	var doc = app.activeDocument;
	
	/*　　　　　　　　　　*/
	/*　ダイアログの準備　*/
	/*　　　　　　　　　　*/
	//文字サイズの単位を取得
	switch (doc.viewPreferences.textSizeMeasurementUnits) {
		case 2054255973 : un = "Q"; break; //級
		case 1514238068 : uns = "ap"; break; //アメリカ式ポイント
		default : un = "pt";
	}
	//ドキュメントデフォルトのフォント名（フルネーム）の取得
	dfd = doc.textDefaults.appliedFont.fullName;
	//ドキュメントフォントリストの作成
	var df = new Array();
	dfs = 0; //次のループで万一一致しなかった場合の保険
	for (i = 0 ; i < doc.fonts.length ; i++) {
		df[i] = doc.fonts[i].name;
		//デフォルトのフォント名（フルネーム）と一致したものをデフォルトにする
		//nameだと一致しない場合がある。小塚明朝ProR
		if (doc.fonts[i].fullName == dfd) dfs = i;
	}
	//スウォッチリストの作成
	var sw = new Array();
	var sj = new Array();
	for (i = 0 ; i < doc.swatches.length ; i++) {
		sw[i] = doc.swatches[i].name;
		switch (sw[i]) {
			case "None"		 : sj[i] = "[なし]"; break;
			case "Paper"		: sj[i] = "[紙色]"; break;
			case "Black"		: sj[i] = "[黒]"; sws = i; break;
			case "Registration" :sj[i] = "[レジストレーション]"; break;
			default:sj[i] = sw[i];
		}
	}
	
	/*　　　　　　　　　　*/
	/*　ダイアログの作成　*/
	/*　　　　　　　　　　*/
	dlg = app.dialogs.add({name:"囲み文字の連続作成"});
	dlg.dialogColumns.add();
	with(dlg.dialogColumns[0].dialogRows.add()){
		staticTexts.add({
			staticLabel:"これは囲み文字を、中に入る文字の大きさを変えて、連続で作成します。"
		});
	}
	with(dlg.dialogColumns[0].dialogRows.add()){
		staticTexts.add({
			staticLabel:"指定できるフォントは、ドキュメントで使用しているものに限ります。"
		});
	}
	with(dlg.dialogColumns[0].dialogRows.add()){
		staticTexts.add({
			staticLabel:"ただし、ドロップダウンリストの制限値より多い場合はエラーになります。"
		});
	}
	dlg.dialogColumns[0].dialogRows.add();
	dlg.dialogColumns[0].dialogRows[-1].dialogColumns.add();
	
	dlg.dialogColumns[0].dialogRows[-1].dialogColumns[0].borderPanels.add();
	dlc = dlg.dialogColumns[0].dialogRows[-1].dialogColumns[0].borderPanels[0].dialogColumns.add();
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"内側（小さくする文字）の縮小率の範囲："});
	}
	with(dlc.dialogRows.add()){
		var size1 = percentEditboxes.add({minWidth:36, editValue:60});
		staticTexts.add({staticLabel:"から"});
		var size2 = percentEditboxes.add({minWidth:36, editValue:90});
		staticTexts.add({staticLabel:"まで、"});
		var sizestep = percentEditboxes.add({minWidth:36, editValue:10});
		staticTexts.add({staticLabel:"刻み"});
	}
	
	dlg.dialogColumns[0].dialogRows[-1].dialogColumns[0].borderPanels.add();
	dlc = dlg.dialogColumns[0].dialogRows[-1].dialogColumns[0].borderPanels[1].dialogColumns.add();
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"外側の文字（囲む文字）："});
		var ch0con = textEditboxes.add({minWidth:72});
	}
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"文字サイズ："});
		var ch0siz = realEditboxes.add({minWidth:72});
		staticTexts.add({staticLabel:un});
	}
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"フォント："});
		var ch0fon = dropdowns.add({stringList:df, selectedIndex:dfs});
	}
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"塗り　　："});
		var ch0col = dropdowns.add({stringList:sj, selectedIndex:sws});
	}
	
	dlg.dialogColumns[0].dialogRows[-1].dialogColumns.add();
	dlg.dialogColumns[0].dialogRows[-1].dialogColumns[1].borderPanels.add();
	dlc = dlg.dialogColumns[0].dialogRows[-1].dialogColumns[1].borderPanels[0].dialogColumns.add();
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"内側の文字（小さくする文字）："});
		var ch1con = textEditboxes.add({minWidth:72});
	}
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"フォント："});
		var ch1fon = radiobuttonGroups.add();
	}
	ch1fon.radiobuttonControls.add({
		staticLabel:"外側と同じ（連動する）", checkedState:true
	});
	ch1fon.radiobuttonControls.add({
		staticLabel:"別に指定する"
	});
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"　　　　　"});
		var ch1fontname = dropdowns.add({stringList:df, selectedIndex:dfs});
	}
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"塗り　　："});
		var ch1col = radiobuttonGroups.add();
	}
	ch1col.radiobuttonControls.add({
		staticLabel:"外側と同じ（連動する）", checkedState:true
	});
	ch1col.radiobuttonControls.add({
		staticLabel:"別に指定する"
	});
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"　　　　　"});
		var ch1fillcolor = dropdowns.add({stringList:sj, selectedIndex:sws});
	}
	
	/*　　　　　　　　　　*/
	/*　ダイアログの表示　*/
	/*　　　　　　　　　　*/
	//入力されていない項目があったらメッセージを表示して再度表示。
	//なお、フォント、塗りについては、無効な値を受け取らないよう、
	//ダイアログで初期値を指定しているところがミソ。
	b = dlg.show();
	while(b) {
		errstr = "";
		if (size1.editValue < 20 || size1.editValue > 1000) {
			errstr += "サイズは20%以上1000%以下にしてください。\n";
		}
		if (size2.editValue < 20 || size2.editValue > 1000) {
			errstr += "サイズは20%以上1000%以下にしてください。\n";
		}
		if (sizestep.editValue < 1 || sizestep.editValue > 100) {
			errstr += "縮小率の刻みは1%以上100%以下にしてください。\n";
		}
		if (ch0con.editContents == "") {
			errstr += "外側の文字が入力されていません。\n";
		}
		if (ch0con.editContents.length > 1){
				errstr += "外側の文字は1文字で指定してください。\n";
		}
		if (ch0siz.editValue < 1 || ch0siz.editValue > 500) {
			errstr += "文字の大きさは1以上500以下にしてください。\n";
		}
		if (ch1con.editContents == "") {
			errstr += "内側の文字が入力されていません。\n";
		}
		tmpstr = ch1con.editContents
		if (ch1con.editContents.length > 1){
				errstr += "内側の文字は1文字で指定してください。\n";
		}
		if (errstr == "") break;
		alert(errstr);
		b = dlg.show();
	}
	//キャンセルボタンがクリックされたらダイアログを解放して終了
	if (!b){
		dlg.destroy();
		return;
	}
	//ダイアログの値を取得してダイアログを解放
	//別の変数に入れているのは単に長いのが嫌いだから
	var startsize = size1.editValue;
	var endsize = size2.editValue;
	var stepsize = sizestep.editValue;
	var pcon = ch0con.editContents;
	var psiz = ch0siz.editValue;
	var pfon = df[ch0fon.selectedIndex];
	var pcol = sw[ch0col.selectedIndex];
	var kcon = ch1con.editContents;
	//圏点文字の大きさksizはポイントでしか設定できないので
	//それ以外の単位の場合は変換が必要
	var ksiz = psiz;
	if (un == "Q") ksiz = ksiz * 0.7087;
	if (un == "ap") ksiz = ksiz * 0.996;
	var kfon = "";
	if (ch1fon.selectedButton == 1) kfon = df[ch1fontname.selectedIndex];
	var kcol = "";
	if (ch1col.selectedButton == 1) kcol = sw[ch1fillcolor.selectedIndex];
	size1 = undefined;
	size2 = undefined;
	sizestep = undefined;
	ch0con = undefined;
	ch0fon = undefined;
	ch0col = undefined;
	ch1con = undefined;
	ch1fon = undefined;
	ch1fontname = undefined;
	ch1col = undefined;
	ch1fillcolor = undefined;
	df = undefined;
	sw = undefined;
	dlg.destroy();
	
	/*　　　　　　　　　*/
	/*　囲み文字の作成　*/
	/*　　　　　　　　　*/
	//定規の単位を組版に合わす
	with (doc.viewPreferences){
		orgH = horizontalMeasurementUnits;
		orgV = verticalMeasurementUnits;
		horizontalMeasurementUnits = typographicMeasurementUnits;
		verticalMeasurementUnits = typographicMeasurementUnits;
	}
	//テキストフレームを作成
	var txf = doc.textFrames.add();
	txf.strokeWeight = 0;
	txf.geometricBounds = [0, 0, psiz, psiz];
	with (txf.textFramePreferences) {
		textColumnCount = 1;
		insetSpacing = [0, 0, 0, 0];
		firstBaselineOffset = 1296386159; //FirstBaseline.EmboxHeight
		ignoreWrap = true;
	}
	with (txf.parentStory) {
		storyPreferences.frameType = 1417176692; //FrameTypes.textFrameType
		storyPreferences.storyOrientation = 1752134266; //StoryHorizontalOrVertical.horizontal
		gridAlignment = 1852796517; //GridAlignment.NONE
		baselineShift = 0;
		gridGyoudori = 0;
		pointSize = psiz;
	}
	//内側の文字のフォントのベースラインを取得
	//圏点の親文字からの間隔で必要
	txf.parentStory.contents = kcon;
	with (txf.texts[0]){
		if (kfon == ""){
			appliedFont = doc.fonts.itemByName(pfon);
		} else {
			appliedFont = doc.fonts.itemByName(kfon);
		}
		var bss = baseline / pointSize;
		contents = "";
	}
	
	//テキストフレーム中に文字を入力
	ipos = -1; //文字位置 -1 は最後尾
	s = startsize;
	e = endsize;
	//大→小の場合に変更する
	if (startsize > endsize) {
		ipos = 0;
		s = endsize;
		e = startsize;
	}
	for (i = s ; i <= e ; i += stepsize){
		//外側の文字を挿入
		//小→大は最後尾に、大→小は先頭に挿入
		txf.insertionPoints[ipos].contents = pcon;
		var cha = txf.characters[ipos];
		//文字の属性を設定
		with (cha){
			appliedFont = pfon; //フォント
			fillColor = doc.swatches.item(pcol); //塗りの色
			kentenKind = KentenCharacter.CUSTOM; //圏点の種類
			//kentenPosition = RubyKentenPosition.ABOVE_RIGHT;
			//kentenAlignment = KentenAlignment.ALIGEN_KENTEN_CENTER;
			if (kcon.length > 1){
				kentenCharacterSet = KentenCharacterSet.UNICODE;
			} else {
				kentenCharacterSet = KentenCharacterSet.CHARACTER_INPUT;
			}
			kentenCustomCharacter = kcon;
			kentenFontSize = ksiz; //圏点文字の大きさ
			if (kfon != ""){
				kentenFont = doc.fonts.itemByName(kfon);
			}
			if (kcol != ""){
				kentenFillColor = doc.swatches.item(kcol);
			}
			kentenXScale = i;
			kentenYScale = i;
			//圏点の親文字からの間隔。ややこしい。二度とできないかも
			minus_shift = -1 * ((100 + i) / 2 + (100 - i) * (1 - bss)) / 100;
			kentenPlacement = ksiz * minus_shift;
		}
		txf.geometricBounds = [0, 0, psiz, txf.geometricBounds[3] + psiz];
	}
	//定規の単位を元に戻す
	doc.viewPreferences.horizontalMeasurementUnits = orgH;
	doc.viewPreferences.verticalMeasurementUnits = orgV;
	
	return;
}
